<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFareRule ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFareRule
 * @subpackage Arrays
 */
class ArrayOfFareRule extends AbstractStructArrayBase
{
    /**
     * The FareRule
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FareRule[]
     */
    public $FareRule;
    /**
     * Constructor method for ArrayOfFareRule
     * @uses ArrayOfFareRule::setFareRule()
     * @param \App|C\StructType\FareRule[] $fareRule
     */
    public function __construct(array $fareRule = array())
    {
        $this
            ->setFareRule($fareRule);
    }
    /**
     * Get FareRule value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FareRule[]|null
     */
    public function getFareRule()
    {
        return isset($this->FareRule) ? $this->FareRule : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFareRule method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareRule method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareRuleForArrayConstraintsFromSetFareRule(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFareRuleFareRuleItem) {
            // validation for constraint: itemType
            if (!$arrayOfFareRuleFareRuleItem instanceof \App|C\StructType\FareRule) {
                $invalidValues[] = is_object($arrayOfFareRuleFareRuleItem) ? get_class($arrayOfFareRuleFareRuleItem) : sprintf('%s(%s)', gettype($arrayOfFareRuleFareRuleItem), var_export($arrayOfFareRuleFareRuleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareRule property can only contain items of type \App|C\StructType\FareRule, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareRule value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\FareRule[] $fareRule
     * @return \App|C\ArrayType\ArrayOfFareRule
     */
    public function setFareRule(array $fareRule = array())
    {
        // validation for constraint: array
        if ('' !== ($fareRuleArrayErrorMessage = self::validateFareRuleForArrayConstraintsFromSetFareRule($fareRule))) {
            throw new \InvalidArgumentException($fareRuleArrayErrorMessage, __LINE__);
        }
        if (is_null($fareRule) || (is_array($fareRule) && empty($fareRule))) {
            unset($this->FareRule);
        } else {
            $this->FareRule = $fareRule;
        }
        return $this;
    }
    /**
     * Add item to FareRule value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\FareRule $item
     * @return \App|C\ArrayType\ArrayOfFareRule
     */
    public function addToFareRule(\App|C\StructType\FareRule $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\FareRule) {
            throw new \InvalidArgumentException(sprintf('The FareRule property can only contain items of type \App|C\StructType\FareRule, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareRule[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\FareRule|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\FareRule|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\FareRule|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\FareRule|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\FareRule|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareRule
     */
    public function getAttributeName()
    {
        return 'FareRule';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfFareRule
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
