<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfItinerary ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfItinerary
 * @subpackage Arrays
 */
class ArrayOfItinerary extends AbstractStructArrayBase
{
    /**
     * The Itinerary
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\Itinerary[]
     */
    public $Itinerary;
    /**
     * Constructor method for ArrayOfItinerary
     * @uses ArrayOfItinerary::setItinerary()
     * @param \App|C\StructType\Itinerary[] $itinerary
     */
    public function __construct(array $itinerary = array())
    {
        $this
            ->setItinerary($itinerary);
    }
    /**
     * Get Itinerary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\Itinerary[]|null
     */
    public function getItinerary()
    {
        return isset($this->Itinerary) ? $this->Itinerary : null;
    }
    /**
     * This method is responsible for validating the values passed to the setItinerary method
     * This method is willingly generated in order to preserve the one-line inline validation within the setItinerary method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateItineraryForArrayConstraintsFromSetItinerary(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfItineraryItineraryItem) {
            // validation for constraint: itemType
            if (!$arrayOfItineraryItineraryItem instanceof \App|C\StructType\Itinerary) {
                $invalidValues[] = is_object($arrayOfItineraryItineraryItem) ? get_class($arrayOfItineraryItineraryItem) : sprintf('%s(%s)', gettype($arrayOfItineraryItineraryItem), var_export($arrayOfItineraryItineraryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Itinerary property can only contain items of type \App|C\StructType\Itinerary, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Itinerary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\Itinerary[] $itinerary
     * @return \App|C\ArrayType\ArrayOfItinerary
     */
    public function setItinerary(array $itinerary = array())
    {
        // validation for constraint: array
        if ('' !== ($itineraryArrayErrorMessage = self::validateItineraryForArrayConstraintsFromSetItinerary($itinerary))) {
            throw new \InvalidArgumentException($itineraryArrayErrorMessage, __LINE__);
        }
        if (is_null($itinerary) || (is_array($itinerary) && empty($itinerary))) {
            unset($this->Itinerary);
        } else {
            $this->Itinerary = $itinerary;
        }
        return $this;
    }
    /**
     * Add item to Itinerary value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\Itinerary $item
     * @return \App|C\ArrayType\ArrayOfItinerary
     */
    public function addToItinerary(\App|C\StructType\Itinerary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\Itinerary) {
            throw new \InvalidArgumentException(sprintf('The Itinerary property can only contain items of type \App|C\StructType\Itinerary, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Itinerary[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\Itinerary|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\Itinerary|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\Itinerary|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\Itinerary|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\Itinerary|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Itinerary
     */
    public function getAttributeName()
    {
        return 'Itinerary';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfItinerary
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
