<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOriginDestination ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOriginDestination
 * @subpackage Arrays
 */
class ArrayOfOriginDestination extends AbstractStructArrayBase
{
    /**
     * The OriginDestination
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\OriginDestination[]
     */
    public $OriginDestination;
    /**
     * Constructor method for ArrayOfOriginDestination
     * @uses ArrayOfOriginDestination::setOriginDestination()
     * @param \App|C\StructType\OriginDestination[] $originDestination
     */
    public function __construct(array $originDestination = array())
    {
        $this
            ->setOriginDestination($originDestination);
    }
    /**
     * Get OriginDestination value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\OriginDestination[]|null
     */
    public function getOriginDestination()
    {
        return isset($this->OriginDestination) ? $this->OriginDestination : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOriginDestination method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOriginDestination method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOriginDestinationForArrayConstraintsFromSetOriginDestination(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOriginDestinationOriginDestinationItem) {
            // validation for constraint: itemType
            if (!$arrayOfOriginDestinationOriginDestinationItem instanceof \App|C\StructType\OriginDestination) {
                $invalidValues[] = is_object($arrayOfOriginDestinationOriginDestinationItem) ? get_class($arrayOfOriginDestinationOriginDestinationItem) : sprintf('%s(%s)', gettype($arrayOfOriginDestinationOriginDestinationItem), var_export($arrayOfOriginDestinationOriginDestinationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OriginDestination property can only contain items of type \App|C\StructType\OriginDestination, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OriginDestination value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\OriginDestination[] $originDestination
     * @return \App|C\ArrayType\ArrayOfOriginDestination
     */
    public function setOriginDestination(array $originDestination = array())
    {
        // validation for constraint: array
        if ('' !== ($originDestinationArrayErrorMessage = self::validateOriginDestinationForArrayConstraintsFromSetOriginDestination($originDestination))) {
            throw new \InvalidArgumentException($originDestinationArrayErrorMessage, __LINE__);
        }
        if (is_null($originDestination) || (is_array($originDestination) && empty($originDestination))) {
            unset($this->OriginDestination);
        } else {
            $this->OriginDestination = $originDestination;
        }
        return $this;
    }
    /**
     * Add item to OriginDestination value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\OriginDestination $item
     * @return \App|C\ArrayType\ArrayOfOriginDestination
     */
    public function addToOriginDestination(\App|C\StructType\OriginDestination $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\OriginDestination) {
            throw new \InvalidArgumentException(sprintf('The OriginDestination property can only contain items of type \App|C\StructType\OriginDestination, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OriginDestination[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\OriginDestination|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\OriginDestination|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\OriginDestination|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\OriginDestination|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\OriginDestination|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OriginDestination
     */
    public function getAttributeName()
    {
        return 'OriginDestination';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfOriginDestination
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
