<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOriginDestinationCalendarQuery ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOriginDestinationCalendarQuery
 * @subpackage Arrays
 */
class ArrayOfOriginDestinationCalendarQuery extends AbstractStructArrayBase
{
    /**
     * The OriginDestinationCalendarQuery
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\OriginDestinationCalendarQuery[]
     */
    public $OriginDestinationCalendarQuery;
    /**
     * Constructor method for ArrayOfOriginDestinationCalendarQuery
     * @uses ArrayOfOriginDestinationCalendarQuery::setOriginDestinationCalendarQuery()
     * @param \App|C\StructType\OriginDestinationCalendarQuery[] $originDestinationCalendarQuery
     */
    public function __construct(array $originDestinationCalendarQuery = array())
    {
        $this
            ->setOriginDestinationCalendarQuery($originDestinationCalendarQuery);
    }
    /**
     * Get OriginDestinationCalendarQuery value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\OriginDestinationCalendarQuery[]|null
     */
    public function getOriginDestinationCalendarQuery()
    {
        return isset($this->OriginDestinationCalendarQuery) ? $this->OriginDestinationCalendarQuery : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOriginDestinationCalendarQuery method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOriginDestinationCalendarQuery method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOriginDestinationCalendarQueryForArrayConstraintsFromSetOriginDestinationCalendarQuery(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOriginDestinationCalendarQueryOriginDestinationCalendarQueryItem) {
            // validation for constraint: itemType
            if (!$arrayOfOriginDestinationCalendarQueryOriginDestinationCalendarQueryItem instanceof \App|C\StructType\OriginDestinationCalendarQuery) {
                $invalidValues[] = is_object($arrayOfOriginDestinationCalendarQueryOriginDestinationCalendarQueryItem) ? get_class($arrayOfOriginDestinationCalendarQueryOriginDestinationCalendarQueryItem) : sprintf('%s(%s)', gettype($arrayOfOriginDestinationCalendarQueryOriginDestinationCalendarQueryItem), var_export($arrayOfOriginDestinationCalendarQueryOriginDestinationCalendarQueryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OriginDestinationCalendarQuery property can only contain items of type \App|C\StructType\OriginDestinationCalendarQuery, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OriginDestinationCalendarQuery value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\OriginDestinationCalendarQuery[] $originDestinationCalendarQuery
     * @return \App|C\ArrayType\ArrayOfOriginDestinationCalendarQuery
     */
    public function setOriginDestinationCalendarQuery(array $originDestinationCalendarQuery = array())
    {
        // validation for constraint: array
        if ('' !== ($originDestinationCalendarQueryArrayErrorMessage = self::validateOriginDestinationCalendarQueryForArrayConstraintsFromSetOriginDestinationCalendarQuery($originDestinationCalendarQuery))) {
            throw new \InvalidArgumentException($originDestinationCalendarQueryArrayErrorMessage, __LINE__);
        }
        if (is_null($originDestinationCalendarQuery) || (is_array($originDestinationCalendarQuery) && empty($originDestinationCalendarQuery))) {
            unset($this->OriginDestinationCalendarQuery);
        } else {
            $this->OriginDestinationCalendarQuery = $originDestinationCalendarQuery;
        }
        return $this;
    }
    /**
     * Add item to OriginDestinationCalendarQuery value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\OriginDestinationCalendarQuery $item
     * @return \App|C\ArrayType\ArrayOfOriginDestinationCalendarQuery
     */
    public function addToOriginDestinationCalendarQuery(\App|C\StructType\OriginDestinationCalendarQuery $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\OriginDestinationCalendarQuery) {
            throw new \InvalidArgumentException(sprintf('The OriginDestinationCalendarQuery property can only contain items of type \App|C\StructType\OriginDestinationCalendarQuery, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OriginDestinationCalendarQuery[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\OriginDestinationCalendarQuery|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\OriginDestinationCalendarQuery|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\OriginDestinationCalendarQuery|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\OriginDestinationCalendarQuery|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\OriginDestinationCalendarQuery|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OriginDestinationCalendarQuery
     */
    public function getAttributeName()
    {
        return 'OriginDestinationCalendarQuery';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfOriginDestinationCalendarQuery
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
