<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CancelSettings StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:CancelSettings
 * @subpackage Structs
 */
class CancelSettings extends ApiObject
{
    /**
     * The CancelSegmentSettings
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\CancelSegmentSettings
     */
    public $CancelSegmentSettings;
    /**
     * The RefundRequestSettings
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\RefundRequestSettings
     */
    public $RefundRequestSettings;
    /**
     * The RefundSettings
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\RefundSettings
     */
    public $RefundSettings;
    /**
     * Constructor method for CancelSettings
     * @uses CancelSettings::setCancelSegmentSettings()
     * @uses CancelSettings::setRefundRequestSettings()
     * @uses CancelSettings::setRefundSettings()
     * @param \App|C\StructType\CancelSegmentSettings $cancelSegmentSettings
     * @param \App|C\StructType\RefundRequestSettings $refundRequestSettings
     * @param \App|C\StructType\RefundSettings $refundSettings
     */
    public function __construct(\App|C\StructType\CancelSegmentSettings $cancelSegmentSettings = null, \App|C\StructType\RefundRequestSettings $refundRequestSettings = null, \App|C\StructType\RefundSettings $refundSettings = null)
    {
        $this
            ->setCancelSegmentSettings($cancelSegmentSettings)
            ->setRefundRequestSettings($refundRequestSettings)
            ->setRefundSettings($refundSettings);
    }
    /**
     * Get CancelSegmentSettings value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\CancelSegmentSettings|null
     */
    public function getCancelSegmentSettings()
    {
        return isset($this->CancelSegmentSettings) ? $this->CancelSegmentSettings : null;
    }
    /**
     * Set CancelSegmentSettings value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\CancelSegmentSettings $cancelSegmentSettings
     * @return \App|C\StructType\CancelSettings
     */
    public function setCancelSegmentSettings(\App|C\StructType\CancelSegmentSettings $cancelSegmentSettings = null)
    {
        if (is_null($cancelSegmentSettings) || (is_array($cancelSegmentSettings) && empty($cancelSegmentSettings))) {
            unset($this->CancelSegmentSettings);
        } else {
            $this->CancelSegmentSettings = $cancelSegmentSettings;
        }
        return $this;
    }
    /**
     * Get RefundRequestSettings value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\RefundRequestSettings|null
     */
    public function getRefundRequestSettings()
    {
        return isset($this->RefundRequestSettings) ? $this->RefundRequestSettings : null;
    }
    /**
     * Set RefundRequestSettings value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\RefundRequestSettings $refundRequestSettings
     * @return \App|C\StructType\CancelSettings
     */
    public function setRefundRequestSettings(\App|C\StructType\RefundRequestSettings $refundRequestSettings = null)
    {
        if (is_null($refundRequestSettings) || (is_array($refundRequestSettings) && empty($refundRequestSettings))) {
            unset($this->RefundRequestSettings);
        } else {
            $this->RefundRequestSettings = $refundRequestSettings;
        }
        return $this;
    }
    /**
     * Get RefundSettings value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\RefundSettings|null
     */
    public function getRefundSettings()
    {
        return isset($this->RefundSettings) ? $this->RefundSettings : null;
    }
    /**
     * Set RefundSettings value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\RefundSettings $refundSettings
     * @return \App|C\StructType\CancelSettings
     */
    public function setRefundSettings(\App|C\StructType\RefundSettings $refundSettings = null)
    {
        if (is_null($refundSettings) || (is_array($refundSettings) && empty($refundSettings))) {
            unset($this->RefundSettings);
        } else {
            $this->RefundSettings = $refundSettings;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\CancelSettings
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
