<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NewCustomerResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:NewCustomerResponse
 * @subpackage Structs
 */
class NewCustomerResponse extends AbstractResponse
{
    /**
     * The NewCustomerResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\NewCustomerResponse
     */
    public $NewCustomerResult;
    /**
     * The Customer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\Customer
     */
    public $Customer;
    /**
     * Constructor method for NewCustomerResponse
     * @uses NewCustomerResponse::setNewCustomerResult()
     * @uses NewCustomerResponse::setCustomer()
     * @param \App|C\StructType\NewCustomerResponse $newCustomerResult
     * @param \App|C\StructType\Customer $customer
     */
    public function __construct(\App|C\StructType\NewCustomerResponse $newCustomerResult = null, \App|C\StructType\Customer $customer = null)
    {
        $this
            ->setNewCustomerResult($newCustomerResult)
            ->setCustomer($customer);
    }
    /**
     * Get NewCustomerResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\NewCustomerResponse|null
     */
    public function getNewCustomerResult()
    {
        return isset($this->NewCustomerResult) ? $this->NewCustomerResult : null;
    }
    /**
     * Set NewCustomerResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\NewCustomerResponse $newCustomerResult
     * @return \App|C\StructType\NewCustomerResponse
     */
    public function setNewCustomerResult(\App|C\StructType\NewCustomerResponse $newCustomerResult = null)
    {
        if (is_null($newCustomerResult) || (is_array($newCustomerResult) && empty($newCustomerResult))) {
            unset($this->NewCustomerResult);
        } else {
            $this->NewCustomerResult = $newCustomerResult;
        }
        return $this;
    }
    /**
     * Get Customer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\Customer|null
     */
    public function getCustomer()
    {
        return isset($this->Customer) ? $this->Customer : null;
    }
    /**
     * Set Customer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\Customer $customer
     * @return \App|C\StructType\NewCustomerResponse
     */
    public function setCustomer(\App|C\StructType\Customer $customer = null)
    {
        if (is_null($customer) || (is_array($customer) && empty($customer))) {
            unset($this->Customer);
        } else {
            $this->Customer = $customer;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\NewCustomerResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
