<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SearchFlightsResponse StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SearchFlightsResponse
 * @subpackage Structs
 */
class SearchFlightsResponse extends AbstractResponse
{
    /**
     * The SearchFlightsResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\SearchFlightsResponse
     */
    public $SearchFlightsResult;
    /**
     * The FareInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FareInfoOptions
     */
    public $FareInfo;
    /**
     * The Offer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\OfferOut
     */
    public $Offer;
    /**
     * The Passengers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfPassenger
     */
    public $Passengers;
    /**
     * The Segments
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfSegmentOption
     */
    public $Segments;
    /**
     * Constructor method for SearchFlightsResponse
     * @uses SearchFlightsResponse::setSearchFlightsResult()
     * @uses SearchFlightsResponse::setFareInfo()
     * @uses SearchFlightsResponse::setOffer()
     * @uses SearchFlightsResponse::setPassengers()
     * @uses SearchFlightsResponse::setSegments()
     * @param \App|C\StructType\SearchFlightsResponse $searchFlightsResult
     * @param \App|C\StructType\FareInfoOptions $fareInfo
     * @param \App|C\StructType\OfferOut $offer
     * @param \App|C\ArrayType\ArrayOfPassenger $passengers
     * @param \App|C\ArrayType\ArrayOfSegmentOption $segments
     */
    public function __construct(\App|C\StructType\SearchFlightsResponse $searchFlightsResult = null, \App|C\StructType\FareInfoOptions $fareInfo = null, \App|C\StructType\OfferOut $offer = null, \App|C\ArrayType\ArrayOfPassenger $passengers = null, \App|C\ArrayType\ArrayOfSegmentOption $segments = null)
    {
        $this
            ->setSearchFlightsResult($searchFlightsResult)
            ->setFareInfo($fareInfo)
            ->setOffer($offer)
            ->setPassengers($passengers)
            ->setSegments($segments);
    }
    /**
     * Get SearchFlightsResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\SearchFlightsResponse|null
     */
    public function getSearchFlightsResult()
    {
        return isset($this->SearchFlightsResult) ? $this->SearchFlightsResult : null;
    }
    /**
     * Set SearchFlightsResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\SearchFlightsResponse $searchFlightsResult
     * @return \App|C\StructType\SearchFlightsResponse
     */
    public function setSearchFlightsResult(\App|C\StructType\SearchFlightsResponse $searchFlightsResult = null)
    {
        if (is_null($searchFlightsResult) || (is_array($searchFlightsResult) && empty($searchFlightsResult))) {
            unset($this->SearchFlightsResult);
        } else {
            $this->SearchFlightsResult = $searchFlightsResult;
        }
        return $this;
    }
    /**
     * Get FareInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FareInfoOptions|null
     */
    public function getFareInfo()
    {
        return isset($this->FareInfo) ? $this->FareInfo : null;
    }
    /**
     * Set FareInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\FareInfoOptions $fareInfo
     * @return \App|C\StructType\SearchFlightsResponse
     */
    public function setFareInfo(\App|C\StructType\FareInfoOptions $fareInfo = null)
    {
        if (is_null($fareInfo) || (is_array($fareInfo) && empty($fareInfo))) {
            unset($this->FareInfo);
        } else {
            $this->FareInfo = $fareInfo;
        }
        return $this;
    }
    /**
     * Get Offer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\OfferOut|null
     */
    public function getOffer()
    {
        return isset($this->Offer) ? $this->Offer : null;
    }
    /**
     * Set Offer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\OfferOut $offer
     * @return \App|C\StructType\SearchFlightsResponse
     */
    public function setOffer(\App|C\StructType\OfferOut $offer = null)
    {
        if (is_null($offer) || (is_array($offer) && empty($offer))) {
            unset($this->Offer);
        } else {
            $this->Offer = $offer;
        }
        return $this;
    }
    /**
     * Get Passengers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfPassenger|null
     */
    public function getPassengers()
    {
        return isset($this->Passengers) ? $this->Passengers : null;
    }
    /**
     * Set Passengers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfPassenger $passengers
     * @return \App|C\StructType\SearchFlightsResponse
     */
    public function setPassengers(\App|C\ArrayType\ArrayOfPassenger $passengers = null)
    {
        if (is_null($passengers) || (is_array($passengers) && empty($passengers))) {
            unset($this->Passengers);
        } else {
            $this->Passengers = $passengers;
        }
        return $this;
    }
    /**
     * Get Segments value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfSegmentOption|null
     */
    public function getSegments()
    {
        return isset($this->Segments) ? $this->Segments : null;
    }
    /**
     * Set Segments value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfSegmentOption $segments
     * @return \App|C\StructType\SearchFlightsResponse
     */
    public function setSegments(\App|C\ArrayType\ArrayOfSegmentOption $segments = null)
    {
        if (is_null($segments) || (is_array($segments) && empty($segments))) {
            unset($this->Segments);
        } else {
            $this->Segments = $segments;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\SearchFlightsResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
