<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SeatArea StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SeatArea
 * @subpackage Structs
 */
class SeatArea extends ApiObject
{
    /**
     * The ColumnSizes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfint
     */
    public $ColumnSizes;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Name;
    /**
     * The Rows
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfSeatRow
     */
    public $Rows;
    /**
     * Constructor method for SeatArea
     * @uses SeatArea::setColumnSizes()
     * @uses SeatArea::setName()
     * @uses SeatArea::setRows()
     * @param \App|C\ArrayType\ArrayOfint $columnSizes
     * @param string $name
     * @param \App|C\ArrayType\ArrayOfSeatRow $rows
     */
    public function __construct(\App|C\ArrayType\ArrayOfint $columnSizes = null, $name = null, \App|C\ArrayType\ArrayOfSeatRow $rows = null)
    {
        $this
            ->setColumnSizes($columnSizes)
            ->setName($name)
            ->setRows($rows);
    }
    /**
     * Get ColumnSizes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfint|null
     */
    public function getColumnSizes()
    {
        return isset($this->ColumnSizes) ? $this->ColumnSizes : null;
    }
    /**
     * Set ColumnSizes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfint $columnSizes
     * @return \App|C\StructType\SeatArea
     */
    public function setColumnSizes(\App|C\ArrayType\ArrayOfint $columnSizes = null)
    {
        if (is_null($columnSizes) || (is_array($columnSizes) && empty($columnSizes))) {
            unset($this->ColumnSizes);
        } else {
            $this->ColumnSizes = $columnSizes;
        }
        return $this;
    }
    /**
     * Get Name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getName()
    {
        return isset($this->Name) ? $this->Name : null;
    }
    /**
     * Set Name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $name
     * @return \App|C\StructType\SeatArea
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->Name);
        } else {
            $this->Name = $name;
        }
        return $this;
    }
    /**
     * Get Rows value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfSeatRow|null
     */
    public function getRows()
    {
        return isset($this->Rows) ? $this->Rows : null;
    }
    /**
     * Set Rows value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfSeatRow $rows
     * @return \App|C\StructType\SeatArea
     */
    public function setRows(\App|C\ArrayType\ArrayOfSeatRow $rows = null)
    {
        if (is_null($rows) || (is_array($rows) && empty($rows))) {
            unset($this->Rows);
        } else {
            $this->Rows = $rows;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\SeatArea
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
